(function ($, Drupal, drupalSettings) {
    Drupal.behaviors.speech_to_text = {
        attach: function (context, settings) {
            "use strict";

            var SpeechRecognition = SpeechRecognition || webkitSpeechRecognition
            var SpeechRecognitionEvent = SpeechRecognitionEvent || webkitSpeechRecognitionEvent

            var recognition = new SpeechRecognition();
            recognition.continuous = false;
            recognition.lang = 'en-US';
            recognition.interimResults = false;
            recognition.maxAlternatives = 1;

            var diagnostic = document.querySelector('.output');

            recognition.onresult = function(event) {
              var transcript = event.results[0][0].transcript;
              document.activeElement.value = transcript; 
            }

            recognition.onspeechend = function() {
              recognition.stop();
            }

            recognition.onnomatch = function(event) {
              console.log("I didn't recognise what your need.");
            }

            recognition.onerror = function(event) {
              console.log('Error occurred in recognition: ' + event.error);
            }
            
            $(once('speech-selector', drupalSettings.speech_to_text.selectors.join(','))).on('focus touch', function() {
              recognition.start();
            });
        }
    }
})(jQuery, Drupal, drupalSettings);